/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: BindingNodePointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the BindingNodePointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=BindingNode.class)
public class BindingNodePointer extends StructurePointer {

	// NULL
	public static final BindingNodePointer NULL = new BindingNodePointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected BindingNodePointer(long address) {
		super(address);
	}

	public static BindingNodePointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static BindingNodePointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static BindingNodePointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new BindingNodePointer(address);
	}

	public BindingNodePointer add(long count) {
		return BindingNodePointer.cast(address + (BindingNode.SIZEOF * count));
	}

	public BindingNodePointer add(Scalar count) {
		return add(count.longValue());
	}

	public BindingNodePointer addOffset(long offset) {
		return BindingNodePointer.cast(address + offset);
	}

	public BindingNodePointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public BindingNodePointer sub(long count) {
		return BindingNodePointer.cast(address - (BindingNode.SIZEOF * count));
	}

	public BindingNodePointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public BindingNodePointer subOffset(long offset) {
		return BindingNodePointer.cast(address - offset);
	}

	public BindingNodePointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public BindingNodePointer untag(long mask) {
		return BindingNodePointer.cast(address & ~mask);
	}

	public BindingNodePointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return BindingNode.SIZEOF;
	}

	// Implementation methods

	// J9AVLTreeNode avlTree
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_avlTreeOffset_", declaredType="J9AVLTreeNode")
	public J9AVLTreeNodePointer avlTree() throws CorruptDataException {
		return J9AVLTreeNodePointer.cast(nonNullFieldEA(BindingNode._avlTreeOffset_));
	}

	// J9AVLTreeNode avlTree
	public PointerPointer avlTreeEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(BindingNode._avlTreeOffset_));
	}

	// void* baseAddress
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_baseAddressOffset_", declaredType="void*")
	public VoidPointer baseAddress() throws CorruptDataException {
		return VoidPointer.cast(getPointerAtOffset(BindingNode._baseAddressOffset_));
	}

	// void* baseAddress
	public PointerPointer baseAddressEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(BindingNode._baseAddressOffset_));
	}

	// U64 extentOfRangeInBytes
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_extentOfRangeInBytesOffset_", declaredType="U64")
	public UDATA extentOfRangeInBytes() throws CorruptDataException {
		return new U64(getLongAtOffset(BindingNode._extentOfRangeInBytesOffset_));
	}

	// U64 extentOfRangeInBytes
	public UDATAPointer extentOfRangeInBytesEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(BindingNode._extentOfRangeInBytesOffset_));
	}

	// U64 j9NodeNumber
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_j9NodeNumberOffset_", declaredType="U64")
	public UDATA j9NodeNumber() throws CorruptDataException {
		return new U64(getLongAtOffset(BindingNode._j9NodeNumberOffset_));
	}

	// U64 j9NodeNumber
	public UDATAPointer j9NodeNumberEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(BindingNode._j9NodeNumberOffset_));
	}

}
